<template>
	<div class="menu">
		<div class="submenu-title">LOBBY LIST</div>
		<component
			v-for="item in items"
			v-on:change="onChange"
			v-on:click="onItemClicked"
			v-on:hover="setSelected"
			:config="item.config"
			:id="item.id"
			:is="item.type"
			:key="item.id"
			:options="item.options"
			:ref="item.ref"
			:selected="item.id === selected"
			:value="item.value"
		>{{ item.text }}</component>
		<div class="right">
			<lobby-list
				v-on:hover="setSelected"
				v-on:join="onJoin"
				ref="list"
				:filtered="this.filter !== ''"
				:id="this.items.length + 1"
				:lobbies="this.lobby_list"
				:selected="this.selected === (this.items.length + 1)"
			/>
		</div>
		<create-new-lobby
			v-if="create_new_lobby"
			v-on:close="onCloseNewLobby"
			v-on:create-lobby="onCreateNewLobby"
			ref="new_lobby"
		/>
	</div>
</template>

<script>

// Constants
const ACTION = require("../../../common/constants/Actions.js")
import CreateNewLobby from "./CreateNewLobby.vue"
import DropdownItem from "../components/DropdownItem.vue"
import InputItem from "../components/InputItem.vue"
import LobbyList from "../components/LobbyList.vue"
import NetworkManager from "../../managers/NetworkManager.js"
import StandardItem from "../components/StandardItem.vue"

import MapOptions from "../../../common/constants/MapOptions.js"
import ModeOptions from "../../../common/constants/ModeOptions.js"
import TeamOptions from "../../../common/constants/TeamOptions.js"

export default {
	components: { CreateNewLobby, DropdownItem, InputItem, LobbyList, StandardItem },
	computed: {
		lobby_list: function () {
			const filter = this.filter.toLowerCase()

			const lobbies = (this.lobbies || []).filter((lobby) => {
				return lobby.name.toLowerCase().indexOf(filter) > -1 ||
					lobby.host.toLowerCase().indexOf(filter) > -1
			})

			return lobbies.sort((la, lb) => {
				switch (this.sort) {
					case "Alphabetical":
						return la.name < lb.name
					case "Emptiness":
						return la.player_count > lb.player_count
				}
			})
		}
	},
	created () {
		UI.on("PRESS_LEFT", () => {
			if (this.mounted) this.pressLeft()
		})
		UI.on("PRESS_RIGHT", () => {
			if (this.mounted) this.pressRight()
		})
		UI.on("PRESS_UP", () => {
			if (this.mounted) this.pressUp()
		})
		UI.on("PRESS_DOWN", () => {
			if (this.mounted) this.pressDown()
		})
		UI.on("PRESS_ENTER", () => {
			if (this.mounted) this.onClick(this.selected)
		})
		UI.on("PRESS_BACK", () => {
			if (this.mounted) {
				this.onBack()
			}
		})
		UI.on("CHANGE_LANGUAGE", () => {
			this.onLanguageChange()
		})
	},
	data () {
		if (!Settings.get("LOBBY_SORTING_OPTION")) {
			Settings.set("LOBBY_SORTING_OPTION", SORTING_OPTIONS[0].name)
		}

		return {
			create_new_lobby: false,
			filter: "",
			items: this.generateItems(),
			lobbies: [],
			mounted: false,
			selected: 0,
			sort: Settings.get("LOBBY_SORTING_OPTION")
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		generateItems: function () {

			let items = [{
				config: {
					size: "small"
				},
				id: 0,
				ref: "r0",
				text: "Filter",
				type: "input-item",
				value: this.filter
			}, {
				id: 1,
				options: SORTING_OPTIONS.map((opt) => {
					return opt.name
				}),
				ref: "r1",
				text: "Sort By",
				type: "dropdown-item",
				value: Settings.get("LOBBY_SORTING_OPTION")
			}, {
				id: 2,
				ref: "r2",
				text: "Create Lobby",
				type: "standard-item"
			}]

			return items
		},
		getNewLobbyComponent: function () {
			return this.$refs.new_lobby
		},
		getSelected: function (id) {
			id = id || this.selected

			if (id < this.items.length) {
				return this.$refs[this.items[id].ref][0]
			} else {
				return this.$refs["list"]
			}
		},
		onBack: function () {
			const item = this.getSelected()
			const modal = this.getNewLobbyComponent()

			if (modal) {
				modal.$emit("PRESS_BACK")
			} else if (item.focused) {
				item.blur()
			} else {
				UI.emit("GO_BACK")
			}
		},
		onChange: function (id, value) {
			switch (id) {
				case 0:
					this.filter = value
					break
				case 1:
					this.sort = SORTING_OPTIONS[value].name
					Settings.set("LOBBY_SORTING_OPTION", this.sort)
					break
			}
			this.items = this.generateItems()
		},
		onClick: function (id) {
			UI.emit("PLAY_CLICK_SOUND")
			const item = this.getSelected(id)
			if (!item.focused) {
				item.onClick()
			} else if (item === this.$refs.r2[0]) {
				this.getNewLobbyComponent().$emit("PRESS_ENTER")
			} else {
				item.$emit("PRESS_ENTER")
			}
		},
		onCloseNewLobby: function () {
			this.create_new_lobby = false
			this.$refs.r2[0].focused = false
		},
		onCreateNewLobby (data) {
			const info = {
				map: MapOptions.find((map) => {
					return map.name === data.map
				}).id,
				mode: ModeOptions.find((mode) => {
					return mode.name === data.mode
				}).id,
				name: data.name,
				teams: TeamOptions.find((teams) => {
					return teams.name === data.teams
				}).id
			}
			Networker.sendAction(ACTION.CREATE_LOBBY, info)
			this.onCloseNewLobby()
		},
		onItemClicked: function (id) {
			window.g = this
			if (id === 2) {
				this.create_new_lobby = true
				this.$refs.r2[0].focused = true
			}
			UI.emit("PLAY_CLICK_SOUND")
			UI.emit("SELECT_OPTIONS_MENU", id)
			this.items = this.generateItems()
		},
		onJoin (room_id) {
			UI.emit("JOIN_LOBBY", {
				id: room_id
			})
		},
		onLanguageChange: function () {
			// this.items[0].text = Language.get("LANGUAGE")
			// // this.items[1].text = Language.get("LOCAL")
			// this.items[1].text = Language.get("LANGUAGE_NAME")
			// // this.items[3].text = Language.get("QUIT")
		},
		pressDown: function () {
			const item = this.getSelected()
			const modal = this.getNewLobbyComponent()

			if (item.focused) {
				if (modal) modal.$emit("PRESS_DOWN")
				item.$emit("PRESS_DOWN")
			} else {
				this.setSelected(Math.min(this.items.length - 1, this.selected + 1))
			}
		},
		pressLeft: function () {
			if (!this.getNewLobbyComponent() && this.selected === this.items.length + 1) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected = 0
			}
		},
		pressRight: function () {
			if (!this.getNewLobbyComponent() && this.selected < this.items.length + 1) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected = this.items.length + 1
			}
		},
		pressUp: function () {
			const item = this.getSelected()
			const modal = this.getNewLobbyComponent()

			if (item.focused) {
				if (modal) modal.$emit("PRESS_UP")
				item.$emit("PRESS_UP")
			} else {
				this.setSelected(Math.max(0, this.selected - 1))
			}
		},
		setSelected: function (id) {
			if (this.selected !== id) {
				UI.emit("PLAY_HOVER_SOUND")
			}
			this.selected = id
		}
	},
	mounted () {
		this.mounted = true

		// Setup networking
		if (!window.Networker) {
			window.Networker = new NetworkManager()
		}
		const that = this
		window.Networker.setCallbacks({
			onData: (data) => {
				switch (data.action) {
					case "CHANGE_ROOM":
						this.onJoin(data.room_id)
						break
				}
			},
			onUpdate: (data) => {
				that.lobbies = data.lobbies
			}
		})
		window.Networker.joinRoom("LOBBY_LIST")
	},
	name: "lobby-list-menu"
}
</script>

<style lang="less" scoped>
@import "./styles/Menu.less";

.menu {
	width: 60em;
}

.right {
	border: 1px #ffffff solid;
	font-size: 4em;
	left: 100%;
	margin-left: 1em;
	position: absolute;
}
</style>